/**********************************************************************
 
	Copyright (C) 2003 Hirohisa MORI <joshua@nichibun.ac.jp>
 
	This program is free software; you can redistribute it 
	and/or modify it under the terms of the GLOBALBASE 
	Library General Public License (G-LGPL) as published by 

	http://www.globalbase.org/
 
	This program is distributed in the hope that it will be 
	useful, but WITHOUT ANY WARRANTY; without even the 
	implied warranty of MERCHANTABILITY or FITNESS FOR A 
	PARTICULAR PURPOSE.

**********************************************************************/


#include	"complex.h"


COMPLEX
addc(COMPLEX a,COMPLEX b)
{
COMPLEX ret;
	ret.im = a.im + b.im;
	ret.re = a.re + b.re;
	return ret;
}

COMPLEX
subc(COMPLEX a,COMPLEX b)
{
COMPLEX ret;
	ret.im = a.im - b.im;
	ret.re = a.re - b.re;
	return ret;
}


COMPLEX
minus(COMPLEX a)
{
	a.im = -a.im;
	a.re = -a.re;
	return a;
}

COMPLEX
mulc(COMPLEX a,COMPLEX b)
{
COMPLEX ret;
	ret.im = a.im*b.re + a.re*b.im;
	ret.re = a.re*b.re - a.im*b.im;
	return ret;
}
